﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DevicesService.Commen
{
    public class Func
    {
        /// <summary>
        /// 读取身份证
        /// </summary>
        public const int IDCardRead = 1;
        /// <summary>
        /// 打印排队票据
        /// </summary>
        public const int SendByPrint = 2;
        /// <summary>
        /// 文字语音播报
        /// </summary>
        public const int payleText = 3;
        /// <summary>
        /// 发送短信
        /// </summary>
        public const int SendSSM = 4;
        /// <summary>
        /// 打开高拍仪并且进行快速扫描文件
        /// </summary>
        public const int openCamera = 5;
        /// <summary>
        /// 打开签字版数据
        /// </summary>
        public const int OpenSign = 6;
        /// <summary>
        /// 关闭签字版
        /// </summary>
        public const int CloseSign = 7;
        /// <summary>
        /// 获取签字版数据
        /// </summary>
        public const int GetSignData = 8;
        /// <summary>
        /// 根据文件地址在线打印
        /// </summary>
        public const int PrintFile = 9;
        /// <summary>
        /// 根据文件base64打印
        /// </summary>
        public const int PrintBase64 = 10;
        /// <summary>
        /// 开始录音、取消录音、结束录音
        /// </summary>
        public const int SoundRecording = 11;
        /// <summary>
        /// 音频文件播放与暂停
        /// </summary>
        public const int Paly = 12;
        /// <summary>
        /// 读取指纹
        /// </summary>
        public const int Finger = 13;
    }
}
